## Here are some ways to use forms 

########################
# By Gram matrix...
########################

f := GF(4);
m := NullMat(4,4,f);
one := One(f);

for t in [1..4] do
  m[t][5-t] := one;
od;

Display(m);

## At the moment, we do not know whether m is a form for
## a hermitian, orthogonal, or symplectic geometry.

form1 := HermitianFormByMatrix(m, f);
form2 := BilinearFormByMatrix(m, f);
form3 := QuadraticFormByMatrix(m, f);

########################
# By polynomial...
########################

r := PolynomialRing( GF(3), 4 );
poly := r.1^2+r.2^2+r.3*r.4;
form := BilinearFormByPolynomial(poly, r);
IsEllipticForm(form);
WittIndex(form);
RadicalOfForm(form);
PolynomialOfForm(form);
IsReflexiveForm(form);
Display(GramMatrix(form));






