##############################################################################
##
#W  gpdhom.g                    GAP4 package `Gpd'               Chris Wensley
#W                                                                & Emma Moore
##
#H  @(#)Id: "gpd/gap/gpdhom.g", v.1.05 2008/11/21  
##
#Y  Copyright (C) 2008, Chris Wensley and Emma Moore,  
#Y  School of Computer Science, Bangor University, U.K. 

SetInfoLevel( InfoGpd, 1 );

Print( "\n================================================================\n");
Print( "<<<< testing morphisms in the Gpd manual (version 21/11/08) >>>>\n" );
Print( "<<<<    functions for groupoids and their homomorphisms     >>>>\n" );
Print( "================================================================\n\n");

d12 := Group( (15,16,17,18,19,20), (15,20)(16,19)(17,18) );;
Gd12 := SinglePieceGroupoid( d12, [-37,-36,-35,-34] );;
SetName( d12, "d12" );  
SetName( Gd12, "Gd12" );
s3d := Subgroup( d12, [ (15,17,19)(16,18,20), (15,20)(16,19)(17,18) ] );
Gs3d := SubgroupoidByPieces( Gd12, [ [ s3d, [-36,-35,-34] ] ] );;
SetName( s3d, "s3d" );  
SetName( Gs3d, "Gs3d" ); 
gend8 := GeneratorsOfGroup( d8 );
imhd8 := [ ( ), (15,20)(16,19)(17,18) ];
hd8 := GroupHomomorphismByImages( d8, s3d, gend8, imhd8 );
homd8 := GroupoidHomomorphism( Gd8, Gs3d, hd8, [-34,-35,-36] );
Print( "homd8 = ", homd8, "\n" );
## Print( IsBijectiveOnObjects( homd8 ), "\n" );
Print( ImagesOfObjects( homd8 ), "\n\n" );

hc6 := GroupHomomorphismByImages( c6, s3d, [(5,6,7)(8,9)], [(15,19)(16,18)] );;
homc6 := GroupoidHomomorphism( Gc6, Gs3d, hc6, [ -36 ] );
Print( "homc6 = " );
Display( homc6 ); 
Print( "\n" ); 

imd8 := [ (1,2,3,4), (2,4) ];
ad8 := GroupHomomorphismByImages( d8, d8, [(1,2,3,4),(1,3)], imd8 );
aGd8 := GroupoidHomomorphism( Gd8, Gd8, ad8, [-8,-7,-9] );
Print( "automorphism aGd8 :-\n" );
Display( aGd8 );
Print( "aGd8 is an automorphism? ", IsGroupoidAutomorphism( aGd8 ), "\n" );
Print( "aGd8 has inverse:\n" );
iaGd8 := InverseGeneralMapping( aGd8 );
Display( iaGd8 ); 
Print( "\n" );
##  Print( "aGd8 has order ", Order( aGd8 ), "\n\n" );

gens3d := GeneratorsOfGroup( s3d );
imas3d := [ (15,17,19)(16,18,20), (15,16)(17,20)(18,19) ];
as3d := GroupHomomorphismByImages( s3d, s3d, gens3d, imas3d );
aGs3d := GroupoidHomomorphism( Gs3d, Gs3d, as3d, [-35,-34,-36] );
Print( "automorphism aGs3d :-\n" );
Display( aGs3d );
Print( "aGs3d is an automorphism? ", IsGroupoidAutomorphism( aGs3d ), "\n" );
Print( "aGs3d has inverse:\n" );
iaGs3d := InverseGeneralMapping( aGs3d );
Display( iaGs3d );
Print( "\n" ); 
## Print( "aGs3d has order ", Order( aGs3d ), "\n\n" );

