gap> START_TEST("HAPprime version 0.3.2 userguide examples");
gap> HAPprimeInfoLevel := InfoLevel(InfoHAPprime);;
gap> SetInfoLevel(InfoHAPprime, 0);;
gap> #
# from paragraph [ 2, 1, 0, 24 ][ "/home/pas/GAP/pkg/happrime-0.3.2/doc/userguide/examples.xml", 129 ]

gap> G := SmallGroup(64, 134);;
gap> # First construct a FG-resolution for the group G
gap> R := ResolutionPrimePowerGroupRadical(G, 10);
Resolution of length 10 in characteristic 2 for <pc group of size 64 with
6 generators> .
No contracting homotopy available.
A partial contracting homotopy is available.

gap> # Convert this into a cochain complex (over the prime field with p=2)
gap> C := HomToIntegersModP(R, 2);
Cochain complex of length 10 in characteristic 2 .

gap> # And get the rank of the 9th cohomology group
gap> b9 := Cohomology(C, 9);
55
gap> 
gap> # Since R is a free resolution, the ranks of the cohomology groups
gap> # are the same as the module ranks in R
gap> ResolutionModuleRanks(R);
[ 3, 6, 10, 15, 21, 28, 36, 45, 55, 66 ]
# from paragraph [ 2, 2, 1, 10 ][ "/home/pas/GAP/pkg/happrime-0.3.2/doc/userguide/examples.xml", 229 ]

gap> G := SmallGroup(16, 3);;
gap> A := ModPCohomologyRing(G, 5);
<algebra of dimension 34 over GF(2)>
gap> ModPCohomologyRingPresentation(A);
Graded algebra GF(2)[ x_1, x_2, x_3, x_4, x_5 ] /
[ x_1*x_2, x_1^2, x_1*x_5, x_2^2*x_3+x_5^2 ] with indeterminate degrees
[ 1, 1, 2, 2, 2 ]
gap> #
gap> SetInfoLevel(InfoHAPprime, HAPprimeInfoLevel);
gap> STOP_TEST("HAPprime/tst/userguideexamples.tst", 5000000000);
