#############################################################################
##
#W  PackageInfo.g                 GAP 4 Package `kan'           Chris Wensley
#W                                                              Anne Heyworth
##
#H  @(#)$Id: PackageInfo.g,v 0.97 2008/11/18 gap Exp $
##

SetPackageInfo( rec(
PackageName := "kan",
Subtitle := "including double coset rewriting systems",

Version := "0.97",
Date := "18/11/2008",
ArchiveURL := "http://www.maths.bangor.ac.uk/chda/kan/kan.0.97", 
ArchiveFormats := ".tar.gz",

TextFiles := ["init.g", "read.g"],
BinaryFiles := ["doc/manual.dvi"],

Persons := [
  rec(
    LastName      := "Heyworth",
    FirstNames    := "Anne",
    IsAuthor      := true,
    IsMaintainer  := false,
    Email         := "anne.heyworth@googlemail.com" 
    ## WWWHome       := "",
    ## PostalAddress := Concatenation( ["\n", "UK"] ),
    ## Place         := "",
    ## Institution   := ""
  ),
  rec(
    LastName      := "Wensley",
    FirstNames    := "Christopher D.",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "c.d.wensley@bangor.ac.uk",
    WWWHome       := "http://www.bangor.ac.uk/~mas023/",
    PostalAddress := Concatenation( [
                       "Dr. C.D. Wensley\n",
                       "School of Computer Science\n",
                       "Bangor University\n",
                       "Dean Street\n",
                       "Bangor\n",
                       "Gwynedd LL57 1UT\n",
                       "UK"] ),
    Place         := "Bangor",
    Institution   := "Bangor University"
  )
],

Status := "deposited",
## CommunicatedBy := "",
## AcceptDate := "",

README_URL := 
  "http://www.maths.bangor.ac.uk/chda/kan/README",
PackageInfoURL :=
  "http://www.maths.bangor.ac.uk/chda/kan/PackageInfo.g",

AbstractHTML :=
 "The Kan package provides a collection of functions for computing with \
  all types of Kan extension, including double coset rewriting systems.",

PackageWWWHome := 
  "http://www.maths.bangor.ac.uk/chda/kan/kan097.html",

PackageDoc := rec(
  BookName  := "Kan",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "Computing with Kan extensions",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [ [ "automata", ">= 1.12" ], 
                             [ "GAPDoc", ">= 1.2" ] ],
  SuggestedOtherPackages := [ [ "kbmag", ">= 1.4" ] ],
  ExternalConditions := [ ]
),

AvailabilityTest := ReturnTrue,

BannerString := Concatenation(
  "--------------------------------------------------------------\n",
  "loading Kan 0.97 for GAP 4.4 - Anne Heyworth and Chris Wensley\n",
  "--------------------------------------------------------------\n" ),

Autoload := false,

TestFile := "tst/kan_manual.tst",

Keywords := [ "Kan extension", "double coset rewriting system", 
              "induced action" ]

));
