#############################################################################
##
#W  drawapery.gd      GAP library     Manuel Delgado <mdelgado@fc.up.pt>
#W                                 Pedro A. Garcia-Sanchez <pedro@ugr.es>
#W                                     Jose Morais    <josejoao@fc.up.pt>
##
#H  @(#)$Id: drawapery.gd,v 1.1 $
##
#Y  Copyright (C)  2004,  CMUP, Universidade do Porto, Portugal
##
############################################################################
##
#V  DrawingsExtraFormat
##
##  This variable holds a string which is a dot output format.
##  If it is different from "none", any drawing will generate also
##  an output in this format.
##
if not IsBound(DrawingsExtraFormat) then
    BindGlobal( "DrawingsExtraFormat", "none" );
fi;

#############################################################################
##
#F  DrawAperyListOfNumericalSemigroup(ap)
##
##  <ap> is the Apery set of a numerical semigroup.
##  This function draws a graph whose vertices are
##  the elements of <ap> and the arrow u -> v exists
##  iff v - u is in <ap>.
##
#############################################################################
DeclareGlobalFunction("DrawAperyListOfNumericalSemigroup");

#############################################################################
##
#F  XDrawAperyListOfNumericalSemigroup(ap)
##
##  The same as above but to be called by XNumericalSemigroup.
##
#############################################################################
DeclareGlobalFunction("XDrawAperyListOfNumericalSemigroup");



#E
