#############################################################################
##
#W  omget.gd           OpenMath Package         Andrew Solomon
##
#H  @(#)$Id: omget.gd,v 1.7 2006/01/27 14:55:55 gap Exp $
##
#Y  Copyright (C)  1997,  Lehrstuhl D fuer Mathematik,  RWTH Aachen,  Germany
#Y  (C) 1998 School Math and Comp. Sci., University of St.  Andrews, Scotland
##
##  Reads an OpenMath object from an input stream and returns
##  a GAP object.
##

Revision.("openmath/gap/omget.gd") :=
    "@(#)$Id: omget.gd,v 1.7 2006/01/27 14:55:55 gap Exp $";

#############################################################################
##
#F  OMGetObject(<stream>)
##
##  <stream> is an input stream (see "ref: InputTextFile", "ref:
##  InputTextUser", "ref: InputTextString", 
##  "ref: InputOutputLocalProcess" ) with an OpenMath object on it.
##  OMGetObject takes precisely one object off <stream> 
##  and returns it as a GAP object.
##  Both XML and binary OpenMath encoding are supported, autodetection
##  is used.
##  This function requires that the external program `gpipe', included
##  in this package, has been compiled.

DeclareGlobalFunction("OMGetObject");

#############################################################################
#E
