#############################################################################
##
#W  parse.gd           OpenMath Package         Andrew Solomon
##
#H  @(#)$Id: parse.gd,v 1.3 2006/01/27 14:55:55 gap Exp $
##
#Y  Copyright (C)  1997,  Lehrstuhl D fuer Mathematik,  RWTH Aachen,  Germany
#Y  (C) 1998 School Math and Comp. Sci., University of St.  Andrews, Scotland
##
##  The parser reads token/values off the stream and builds GAP objects.
##  

Revision.("openmath/gap/parse.gd") :=
    "@(#)$Id: parse.gd,v 1.3 2006/01/27 14:55:55 gap Exp $";


#############################################################################
##
## Parser for the 'abstract grammar' given by:
##
## basic -> integer | float | string | bytearray | symbol | variable
## object -> basic | application | attribution | binding | error
## objects -> | object objects
## attrs ->  symbol object | symbol object attrs 
## application -> 'Application'(object objects)
## attribution -> 'Attribution'( attrs object )
## binding -> 'Binding'(object variables object)
## error -> 'Error'(symbol objects)
##


DeclareGlobalFunction("OMgetObjectByteStream");
DeclareGlobalFunction("OMparseStart");
DeclareGlobalFunction("OMparseApplication");
DeclareGlobalFunction("OMparseAttribution");
DeclareGlobalFunction("OMparseBind");
DeclareGlobalFunction("OMparseObject");

