#############################################################################
##
##  PackageInfo.g   file for the package XMod version 2.12  (24/11/08)
##  Chris Wensley and Murat Alp
##

SetPackageInfo( rec(
PackageName := "XMod",
Subtitle := "Crossed Modules and Cat1-Groups",

Version := "2.12",
Date := "24/11/2008",
ArchiveURL := "http://www.maths.bangor.ac.uk/chda/xmod/xmod.2.12", 
ArchiveFormats := ".tar.gz",

TextFiles := ["init.g", "read.g"],
BinaryFiles := ["doc/manual.dvi"],

Persons := [
  rec(
    LastName      := "Wensley",
    FirstNames    := "Christopher D.",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "c.d.wensley@bangor.ac.uk",
    WWWHome       := "http://www.bangor.ac.uk/~mas023/",
    PostalAddress := Concatenation( [
                       "Dr. C.D. Wensley\n",
                       "School of Computer Science\n",
                       "Bangor University\n",
                       "Dean Street\n",
                       "Bangor\n",
                       "Gwynedd LL57 1UT\n",
                       "UK"] ),
    Place         := "Bangor",
    Institution   := "Bangor University"
  ),
  rec(
    LastName      := "Alp",
    FirstNames    := "Murat",
    IsAuthor      := true,
    Email         := "malp@dumlupinar.edu.tr",
    PostalAddress := Concatenation( [
                       "Dr. M. Alp\n",
                       "Dumlupinar Universitesi\n",
                       "Fen-Edebiyat Fakultesi\n",
                       "Matematik Bolumu\n",
                       "Merkez Kampus\n",
                       "Kutahya\n",
                       "Turkey"] ),
    Place         := "Kutahya",
    Institution   := "Dumlupinar University"
  )
],

Status := "accepted",
CommunicatedBy := "Derek Holt (Warwick)",
AcceptDate := "12/1996",

README_URL := 
  "http://www.maths.bangor.ac.uk/chda/xmod/README",
PackageInfoURL :=
  "http://www.maths.bangor.ac.uk/chda/xmod/PackageInfo.g",

AbstractHTML :=
 "The XMod package provides a collection of functions for computing with \
crossed modules and cat1-groups, their derivations and sections, \
and morphisms of these structures.",

PackageWWWHome := 
  "http://www.maths.bangor.ac.uk/chda/xmod/xmod212.html",

PackageDoc := rec(
  BookName  := "XMod",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "Crossed Modules and Cat1-Groups in GAP",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [ ["Gpd", ">= 1.05"] ],
  SuggestedOtherPackages := [ ["GAPDoc", ">= 1.2"] ],
  ExternalConditions := [ ]
),

AvailabilityTest := ReturnTrue,

BannerString := Concatenation( 
  "-----------------------------------------------------------\n", 
  "loading XMod 2.12 for GAP 4.4 - Murat Alp and Chris Wensley\n",
  "-----------------------------------------------------------\n" ),

Autoload := false,

TestFile := "tst/xmod_manual.tst",

Keywords := ["crossed module","cat1-group","derivation","section","actor"]

));
